aboutsummaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
authorDavid Bremner <david@tethera.net>2021-01-17 08:35:38 -0400
committerDavid Bremner <david@tethera.net>2021-01-17 13:24:04 -0400
commit6a7b61b1d50bf25ebce61fa58af1c195951b387c (patch)
tree633f3f023d4ea78874fed2e552247cd0d8807b11 /test
parent15d8067c0a209a24d757b416107d92007529f01f (diff)
test: add (back) upgrade tests
In ee897cab8b721 the upgrade tests from pre v3 databases were removed. The reasons for that are still valid, but we should still test the code paths that do the upgrade, and it is relatively straightforward to do that for v3 to v3 upgrades.
Diffstat (limited to 'test')
-rw-r--r--test/README1
-rwxr-xr-xtest/T530-upgrade.sh57
-rw-r--r--test/test-lib.sh1
3 files changed, 59 insertions, 0 deletions
diff --git a/test/README b/test/README
index 11eaf18f..10f127cb 100644
--- a/test/README
+++ b/test/README
@@ -25,6 +25,7 @@ that you know if you break anything.
- gdb(1)
- gpg(1)
- python(1)
+ - xapian-metadata(1)
If your system lacks these tools or have older, non-upgradable versions
of these, please (possibly compile and) install these to some other
diff --git a/test/T530-upgrade.sh b/test/T530-upgrade.sh
new file mode 100755
index 00000000..c599dacf
--- /dev/null
+++ b/test/T530-upgrade.sh
@@ -0,0 +1,57 @@
+#!/usr/bin/env bash
+test_description='database upgrades'
+. $(dirname "$0")/test-lib.sh || exit 1
+
+test_require_external_prereq xapian-metadata
+
+XAPIAN_PATH=$MAIL_DIR/.notmuch/xapian
+BACKUP_PATH=$MAIL_DIR/.notmuch
+
+delete_feature () {
+ local key=$1
+ features=$(xapian-metadata get $XAPIAN_PATH features | grep -v "^$key")
+ xapian-metadata set $XAPIAN_PATH features "$features"
+}
+
+add_email_corpus
+
+for key in 'multiple paths per message' \
+ 'relative directory paths' \
+ 'exact folder:/path: search' \
+ 'mail documents for missing messages' \
+ 'modification tracking'; do
+ backup_database
+ test_begin_subtest "upgrade is triggered by missing '$key'"
+ delete_feature "$key"
+ output=$(notmuch new | grep Welcome)
+ test_expect_equal \
+ "$output" \
+ "Welcome to a new version of notmuch! Your database will now be upgraded."
+
+ restore_database
+
+ backup_database
+ test_begin_subtest "backup can be restored ['$key']"
+ notmuch dump > BEFORE
+ delete_feature "$key"
+ notmuch new
+ notmuch tag -inbox '*'
+ dump_file=$(echo ${BACKUP_PATH}/dump*)
+ notmuch restore --input=$dump_file
+ notmuch dump > AFTER
+ test_expect_equal_file BEFORE AFTER
+ restore_database
+done
+
+for key in 'from/subject/message-ID in database' \
+ 'indexed MIME types' \
+ 'index body and headers separately'; do
+ backup_database
+ test_begin_subtest "upgrade not triggered by missing '$key'"
+ delete_feature "$key"
+ output=$(notmuch new | grep Welcome)
+ test_expect_equal "$output" ""
+ restore_database
+done
+
+test_done
diff --git a/test/test-lib.sh b/test/test-lib.sh
index c23a0d20..29baa0c1 100644
--- a/test/test-lib.sh
+++ b/test/test-lib.sh
@@ -1270,3 +1270,4 @@ test_declare_external_prereq gpg
test_declare_external_prereq openssl
test_declare_external_prereq gpgsm
test_declare_external_prereq ${NOTMUCH_PYTHON}
+test_declare_external_prereq xapian-metadata